# coding: utf-8

"""
    Flat API

    The Flat API allows you to easily extend the abilities of the [Flat Platform](https://flat.io), with a wide range of use cases including the following:  * Creating and importing new music scores using MusicXML or MIDI files * Browsing, updating, copying, exporting the user's scores (for example in MP3, WAV or MIDI) * Managing educational resources with Flat for Education: creating & updating the organization accounts, the classes, rosters and assignments.  The Flat API is built on HTTP. Our API is RESTful It has predictable resource URLs. It returns HTTP response codes to indicate errors. It also accepts and returns JSON in the HTTP body. The [schema](/swagger.yaml) of this API follows the [OpenAPI Initiative (OAI) specification](https://www.openapis.org/), you can use and work with [compatible Swagger tools](http://swagger.io/open-source-integrations/). This API features Cross-Origin Resource Sharing (CORS) implemented in compliance with [W3C spec](https://www.w3.org/TR/cors/).  You can use your favorite HTTP/REST library for your programming language to use Flat's API. This specification and reference is [available on Github](https://github.com/FlatIO/api-reference).  Getting Started and learn more:  * [API Overview and interoduction](https://flat.io/developers/docs/api/) * [Authentication (Personal Access Tokens or OAuth2)](https://flat.io/developers/docs/api/authentication.html) * [SDKs](https://flat.io/developers/docs/api/sdks.html) * [Rate Limits](https://flat.io/developers/docs/api/rate-limits.html) * [Changelog](https://flat.io/developers/docs/api/changelog.html)   # noqa: E501

    OpenAPI spec version: 2.6.0
    Contact: developers@flat.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from flat_api.models.class_roles import ClassRoles  # noqa: F401,E501
from flat_api.models.organization_roles import OrganizationRoles  # noqa: F401,E501
from flat_api.models.user_details_admin_license import UserDetailsAdminLicense  # noqa: F401,E501
from flat_api.models.user_public_summary import UserPublicSummary  # noqa: F401,E501


class UserDetailsAdmin(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'email': 'str',
        'last_activity_date': 'datetime',
        'license': 'UserDetailsAdminLicense'
    }

    attribute_map = {
        'email': 'email',
        'last_activity_date': 'lastActivityDate',
        'license': 'license'
    }

    def __init__(self, email=None, last_activity_date=None, license=None):  # noqa: E501
        """UserDetailsAdmin - a model defined in Swagger"""  # noqa: E501

        self._email = None
        self._last_activity_date = None
        self._license = None
        self.discriminator = None

        if email is not None:
            self.email = email
        if last_activity_date is not None:
            self.last_activity_date = last_activity_date
        if license is not None:
            self.license = license

    @property
    def email(self):
        """Gets the email of this UserDetailsAdmin.  # noqa: E501

        Email of the user  # noqa: E501

        :return: The email of this UserDetailsAdmin.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this UserDetailsAdmin.

        Email of the user  # noqa: E501

        :param email: The email of this UserDetailsAdmin.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def last_activity_date(self):
        """Gets the last_activity_date of this UserDetailsAdmin.  # noqa: E501

        Date of the last user activity  # noqa: E501

        :return: The last_activity_date of this UserDetailsAdmin.  # noqa: E501
        :rtype: datetime
        """
        return self._last_activity_date

    @last_activity_date.setter
    def last_activity_date(self, last_activity_date):
        """Sets the last_activity_date of this UserDetailsAdmin.

        Date of the last user activity  # noqa: E501

        :param last_activity_date: The last_activity_date of this UserDetailsAdmin.  # noqa: E501
        :type: datetime
        """

        self._last_activity_date = last_activity_date

    @property
    def license(self):
        """Gets the license of this UserDetailsAdmin.  # noqa: E501


        :return: The license of this UserDetailsAdmin.  # noqa: E501
        :rtype: UserDetailsAdminLicense
        """
        return self._license

    @license.setter
    def license(self, license):
        """Sets the license of this UserDetailsAdmin.


        :param license: The license of this UserDetailsAdmin.  # noqa: E501
        :type: UserDetailsAdminLicense
        """

        self._license = license

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserDetailsAdmin):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
